import { Command, CommandResult, CommandOptions, CommandCallback } from 'resolve-client';
import { HookExecutor } from './generic';
export declare type CommandBuilder<T> = (data: T) => Command;
export declare type CommandExecutor<T> = HookExecutor<T, CommandResult>;
declare function useCommand(command: Command): CommandExecutor<void>;
declare function useCommand(command: Command, options: CommandOptions): CommandExecutor<void>;
declare function useCommand(command: Command, callback: CommandCallback): CommandExecutor<void>;
declare function useCommand(command: Command, dependencies: any[]): CommandExecutor<void>;
declare function useCommand(command: Command, callback: CommandCallback, dependencies: any[]): CommandExecutor<void>;
declare function useCommand(command: Command, options: CommandOptions, callback: CommandCallback): CommandExecutor<void>;
declare function useCommand(command: Command, options: CommandOptions, dependencies: any[]): CommandExecutor<void>;
declare function useCommand(command: Command, options: CommandOptions, callback: CommandCallback, dependencies: any[]): CommandExecutor<void>;
declare function useCommand<T>(builder: CommandBuilder<T>): CommandExecutor<T>;
declare function useCommand<T>(builder: CommandBuilder<T>, options: CommandOptions): CommandExecutor<T>;
declare function useCommand<T>(builder: CommandBuilder<T>, callback: CommandCallback): CommandExecutor<T>;
declare function useCommand<T>(builder: CommandBuilder<T>, dependencies: any[]): CommandExecutor<T>;
declare function useCommand<T>(builder: CommandBuilder<T>, callback: CommandCallback, dependencies: any[]): CommandExecutor<T>;
declare function useCommand<T>(builder: CommandBuilder<T>, options: CommandOptions, callback: CommandCallback): CommandExecutor<T>;
declare function useCommand<T>(builder: CommandBuilder<T>, options: CommandOptions, dependencies: any[]): CommandExecutor<T>;
declare function useCommand<T>(builder: CommandBuilder<T>, options: CommandOptions, callback: CommandCallback, dependencies: any[]): CommandExecutor<T>;
export { useCommand };
